program papy;

uses funit,clavier;

var
speed:byte; (* vitesse du jeu (petites machines) *)
timer:longint; (* compteur *)
ecrx,ecry:longint; (* coords de l'cran (scrolling) *)
soltype:byte; (* type de sol du stage *)
direc:array[1..2,1..2] of byte; (* vecteur direction du joueur *)
state:array[1..2] of byte; (* statut des joueurs *)
cles:array[1..2] of byte; (* nombre de cls *)
score:array[1..2] of longint; (* score *)
vie:array[1..2] of longint; (* vie *)
color:array[1..2] of byte; (* couleur des mecs *)
stage:pointer; (* dessin du stage *)


procedure affiche;
(* affiche le stage en fonction de ecrx et ecry *)
const c:array[0..11] of byte=(28,25,28,23,24,17,18,19,21,20,22,33);
var x,y:integer;
xm,ym,p:byte;
begin
if (ecrx<16) or (ecry<16) or (ecrx>5104) or (ecry>3184) then halt(1);
xm:=ecrx mod 16;
ym:=ecry mod 16;
for y:=-1 to 15 do for x:=-1 to 21 do    (* ! -1  la place de 0 *)
begin
     p:=point(stage,(ecrx div 16)+x,(ecry div 16)+y);
     affimage(back,soltype,x*16-xm,y*16-ym);
     if (p<>2) and (p<12) then affimage(back,c[p],x*16-xm,y*16-ym);
     if p=48 then affimage(back,34,x*16-xm,y*16-ym);
end;
end;

procedure lodstage;
(* charge le stage *)
begin
(* mettre le fichier PAPY.FML (comme levels) avec chargedat *)
chargebmp(stage,'levels.bmp',false);
end;

procedure huntdepart(a:byte);
(* cherche le point de dpart na, le centre... *)
var c,b,r:longint;
begin
c:=a;
for b:=0 to 63999 do if peek(stage,b)=0 then begin dec(c);if c=0 then r:=b;b:=63999;end;
ecrx:=(r mod 320);
ecry:=(r div 320);
soltype:=point(stage,ecrx,ecry+1);
plot(stage,ecrx,ecry,soltype);
case soltype of
   2:soltype:=29;
end;
ecrx:=ecrx*16-160;
ecry:=ecry*16-100;
end;

procedure chargesprites;
(* charge les sprites *)
var a:word;
begin
for a:=1 to 38 do chargeimage(a,a,'papy.fms');
for a:=1 to 12 do chargeimage(a+900,a,'papy.fms'); (* papy joueur 2 *)
end;

procedure entete;
(* entete et vie des joueurs *)
var a:byte;
begin
for a:=0 to 1 do
begin
ecris(back,a*180+1,1,5,'papy '+st(a+1));
ecris(back,a*180+1,7,5,'score : '+st(score[a+1]));
ecris(back,a*180+1,13,5,'vital : '+st(vie[a+1] div 100));
affimage(back,23,a*180+90,6);
ecris(back,a*180+110,10,5,'= '+st(cles[a+1]));
case state[a+1] of
   0:ecris(back,a*180+32,1,5,'Game over / press start');
   1:ecris(back,a*180+32,1,color[a+1],'bonne chance !!');
end;


end;
end;

function detect(x,y:longint):byte;
(* retourne le type de texel  x,y dvelopp *)
begin
detect:=point(stage,x div 16,y div 16);
end;

function place(x,y:longint):boolean;
(* vrifie si l'on peut mettre un objet en place *)
begin
place:=(detect(x,y)=2) and (detect(x-7,y)=2) and (detect(x+7,y)=2) and (detect(x,y-7)=2) and (detect(x,y+7)=2);
end;

procedure cree(x,y:longint;n:word;a:integer);
(* cre le sprite a. Si a=0, cherche un sprite dispo (mettre -1... pour fireball... *)
begin
(* if a<=0 *)
if place(x-ecrx,y-ecry) then setsprite(a,x-ecrx,y-ecry,n)
else if not spexist(a) then
 begin cree(x-1-ecrx,y-ecry,n,a);cree(x+1-ecrx,y-ecry,n,a);cree(x-ecrx,y-1-ecry,n,a);cree(x-ecrx,y+1-ecry,n,a);end;


end;

procedure fill(x,y:integer;a,c:byte);
(* remplace les couleurs a par des c *)
var p:byte;
begin
p:=point(stage,x,y);
if (p=a) and (x>=0) and (x<320) and (y>0) and (y<200) then
 begin
  plot(stage,x,y,c);
  fill(x-1,y,a,c);
  fill(x+1,y,a,c);
  fill(x,y-1,a,c);
  fill(x,y+1,a,c);
 end;
end;

procedure vireobj(j,c:byte);
(* vire un objet *)
begin
fill((ecrx+spx(j)-2) div 16,(ecry+spy(j)+8) div 16,c,2);
fill((ecrx+spx(j)+8) div 16,(ecry+spy(j)+18) div 16,c,2);
fill((ecrx+spx(j)+8) div 16,(ecry+spy(j)-2) div 16,c,2);
fill((ecrx+spx(j)+18) div 16,(ecry+spy(j)+8) div 16,c,2);
end;

procedure testobj(j,c:byte);
(* test les objets / interraction avec le dcor *)
begin
case c of
  3:begin vireobj(j,3);cles[j]:=cles[j]+1;end;    (* cle *)
  4:if cles[j]>0 then begin dec(cles[j]);vireobj(j,4);end; (* serrure *)
  8:begin vireobj(j,8);score[j]:=score[j]+1000;end; (* tresor *)
  5:begin vireobj(j,5);vie[j]:=vie[j]+5000;end; (* vie *)
  6:begin vireobj(j,6);vie[j]:=vie[j]+10000;end; (* vie *2 *)
  7:begin vireobj(j,7);vie[j]:=vie[j]+20000;end; (* vie *4 *)
 10:begin vireobj(j,10);vie[j]:=vie[j]+50000;end; (* vie *10 *)

end;
end;

function sgn(a:shortint):shortint;
(* renvoie le signe de a *)
begin
if a<0 then sgn:=-1;
if a>0 then sgn:=1;
if a=0 then sgn:=0;
end;

procedure movy(j:byte;a:shortint);
(* deplacement vertical *)
var c,b:byte;
s:shortint;
begin
direc[j,1]:=sgn(a);direc[j,2]:=0;
c:=detect(8+ecrx+spx(j),8+ecry+spy(j)+sgn(a)*7);
testobj(j,c);
if (c<>1) and (c<>48) and (c<>4) and (((a>0) and (spy(j)<180)) or ((a<0) and (spy(j)>10))) then
begin (* dplacement *)
setsppos(j,spx(j),spy(j)+a);
if not spexist(3-j) then setsppos(3-j,spx(j),spy(j));
s:=sgn(100-((spy(j)+spy(3-j)) div 2));
ecry:=ecry-s*abs(a);
for b:=1 to 100 do setsppos(b,spx(b),spy(b)+s*abs(a));
end;
end;

procedure movx(j:byte;a:shortint);
(* deplacement horizontal *)
var c,b:byte;
s:shortint;
begin
direc[j,2]:=sgn(a);direc[j,1]:=0;
c:=detect(8+ecrx+spx(j)+sgn(a)*6,8+ecry+spy(j));
testobj(j,c);
if (c<>1) and (c<>48) and (c<>4) and (((a>0) and (spx(j)<300)) or ((a<0) and (spx(j)>10))) then
begin (* dplacement *)
setsppos(j,spx(j)+a,spy(j));
if not spexist(3-j) then setsppos(3-j,spx(j),spy(j));
s:=sgn(160-((spx(j)+spx(3-j)) div 2));
ecrx:=ecrx-s*abs(a);
for b:=1 to 100 do setsppos(b,spx(b)+s*abs(a),spy(b));
end;
end;

procedure input;
(* entres : ce qui rend le jeu interactif. Important ? si peu ... *)
const code:array[1..2,1..5] of byte=((17,31,30,32,25),(72,80,75,77,83));
var a:byte;
begin
for a:=1 to 2 do
case state[a] of
   0:if touche[code[a,5]] then (* apparition *)
        begin state[a]:=1;vie[a]:=400000;score[a]:=0;cree(ecrx+160,ecry+100,1+(a-1)*900,a);cles[a]:=0;end;
   1:(* statut marche *)
    begin
      vie[a]:=vie[a]-speed;
   if touche[code[a,2]] (* bas *) then begin movy(a,speed);setimage(a,900*(a-1)+1+((timer div (18 div speed)) mod 3));end;
   if touche[code[a,1]] (* haut *) then begin movy(a,-speed);setimage(a,900*(a-1)+4+((timer div (18 div speed)) mod 3));end;
   if touche[code[a,3]] (* gauche *) then begin movx(a,-speed);setimage(a,900*(a-1)+10+((timer div (18 div speed)) mod 3));end;
   if touche[code[a,4]] (* droite *) then begin movx(a,speed);setimage(a,900*(a-1)+7+((timer div (18 div speed)) mod 3));end;


    end;

end;
end;

procedure fantomes;
(* crateur de fantomes *)
begin




end;

procedure jeu;
(* gestion jeu *)
var x,y:longint;
a:real;
begin
lodstage;
huntdepart(1);
timer:=0;
repeat (* boucle de jeu *)
inc(timer);
(* enemis *)
fantomes;


(* // *)
input;
affiche;
entete;
anim;
until bouton(1);
end;

procedure mutecolor;
(* change les pxls internes des sprites *)
var a:word;b:word;
begin
for a:=1 to 12 do for b:=6 to 262 do if peek(image[a],b)=254 then poke(image[a],b,color[1]);
for a:=901 to 912 do for b:=6 to 262 do if peek(image[a],b)=254 then poke(image[a],b,color[2]);
end;

begin
graphon;
clavbinon;
speed:=1;

state[1]:=0;state[2]:=0;
stage:=nouvzone(ecran);
chargepalette('papy.fmp');
chargesprites;
color[1]:=3;color[2]:=1;mutecolor;
(* presente et tout *)
jeu;

repeat until bouton(1);
clavbinoff;
end.